using System.ComponentModel;
using Eco.Persistence;
using Eco.Persistence.Configuration;
using Eco.Handles.Design;

namespace Eco.Persistence.Design
{
	internal class SQLServerConfiguratorSqlClient: IMapperVerbConfigurator
	{
		public string Caption() { return PersistenceStringRes.sSqlServerSetup; }
		public object PersistenceMapperType() { return typeof(PersistenceMapperSqlServer); }
		public void ConfigureBackend(SqlDatabaseConfig sqlDatabaseConfig)
		{
			DatabaseEngineInitializer.InitializeDbEngineSettings(DataBaseEngine.SqlServerSqlClient, sqlDatabaseConfig);
		}
		public bool IsVerbFor(Component component) { return true; }
	}

  internal class SQLServer7ConfiguratorSqlCe : IMapperVerbConfigurator
	{
		public string Caption() { return "SqlCe"; }
		public object PersistenceMapperType() { return typeof(PersistenceMapperSqlServer); }
		public void ConfigureBackend(SqlDatabaseConfig sqlDatabaseConfig)
		{
      DatabaseEngineInitializer.InitializeDbEngineSettings(DataBaseEngine.SqlCe, sqlDatabaseConfig);
		}
		public bool IsVerbFor(Component component) { return true; }
	}

  internal class SQLServer7ConfiguratorSqlClient: IMapperVerbConfigurator
	{
		public string Caption() { return PersistenceStringRes.sSqlServer7Setup; }
		public object PersistenceMapperType() { return typeof(PersistenceMapperSqlServer); }
		public void ConfigureBackend(SqlDatabaseConfig sqlDatabaseConfig)
		{
			DatabaseEngineInitializer.InitializeDbEngineSettings(DataBaseEngine.SqlServer7SqlClient, sqlDatabaseConfig);
		}
		public bool IsVerbFor(Component component) { return true; }
	}
	internal class SQLServerConfiguratorSqlClientMBCS: IMapperVerbConfigurator
	{
		public string Caption() { return PersistenceStringRes.sSqlServerMBCSSetup; }
		public object PersistenceMapperType() { return typeof(PersistenceMapperSqlServer); }
		public void ConfigureBackend(SqlDatabaseConfig sqlDatabaseConfig)
		{
			DatabaseEngineInitializer.InitializeDbEngineSettings(DataBaseEngine.SqlServerMBCSSqlClient, sqlDatabaseConfig);
		}
		public bool IsVerbFor(Component component) { return true; }
	}
	internal class SQLServer7ConfiguratorSqlClientMBCS: IMapperVerbConfigurator
	{
		public string Caption() { return PersistenceStringRes.sSqlServer7MBCSSetup; }
		public object PersistenceMapperType() { return typeof(PersistenceMapperSqlServer); }
		public void ConfigureBackend(SqlDatabaseConfig sqlDatabaseConfig)
		{
			DatabaseEngineInitializer.InitializeDbEngineSettings(DataBaseEngine.SqlServer7MBCSSqlClient, sqlDatabaseConfig);
		}
		public bool IsVerbFor(Component component) { return true; }
	}
	/*
     * internal class AccessConfiguratorSqlClient: IMapperVerbConfigurator
	{
		public string Caption() { return PersistenceStringRes.sAccessSetup; }
		public object PersistenceMapperType() { return typeof(PersistenceMapperSqlServer); }
		public void ConfigureBackend(SqlDatabaseConfig sqlDatabaseConfig)
		{
			DatabaseEngineInitializer.InitializeDbEngineSettings(DataBaseEngine.AccessSqlClient, sqlDatabaseConfig);
		}
		public bool IsVerbFor(Component component) { return true; }
	}
     * */
}