using System;
using System.ComponentModel;
using System.Collections;

using Microsoft.Data.SqlClient;
using System.Windows.Forms;
using Eco.Persistence;
using Eco.Ide;
using Eco.Persistence.Design;
using Eco.Handles.Design;

namespace Eco.Persistence.Design
{
	public class SqlServerPersistenceHandleDesigner: PersistenceHandleDesigner
	{
		static SqlServerPersistenceHandleDesigner()
		{
			PersistenceMapperSqlServer.RegisterAttributeMappers();
			RegisterConfigurators();
			RegisterValidators();
		}
		private static void RegisterValidators()
		{
			FormValidator.Registry.Add(new PMapperSqlServerValidator());
		}
		private static void RegisterConfigurators()
		{
			PersistenceHandleDesigner.RegisterConfigurator(new SQLServerConfiguratorSqlClient());
			PersistenceHandleDesigner.RegisterConfigurator(new SQLServer7ConfiguratorSqlClient());
			PersistenceHandleDesigner.RegisterConfigurator(new SQLServerConfiguratorSqlClientMBCS());
			PersistenceHandleDesigner.RegisterConfigurator(new SQLServer7ConfiguratorSqlClientMBCS());
      PersistenceHandleDesigner.RegisterConfigurator(new SQLServer7ConfiguratorSqlCe());
      // PersistenceHandleDesigner.RegisterConfigurator(new AccessConfiguratorSqlClient());
		}

		public SqlServerPersistenceHandleDesigner() {}
		public override void InitializeNewComponent(IDictionary defaultValues)
		{
			base.InitializeNewComponent(defaultValues);
			InitializeComponent(new SQLServerConfiguratorSqlClient());
		}

		public void CheckInitialize(object sender, EventArgs e)
		{
			Application.Idle -= new EventHandler(CheckInitialize);
      if (Component is PersistenceMapperDb)
      {
        if (!((PersistenceMapperDb)Component).SqlDatabaseConfig.ConfigValid)
          InitializeComponent(new SQLServerConfiguratorSqlClient());
      }
		}

		public override void Initialize(IComponent component)
		{
			base.Initialize(component);
			// at this point, the codedom isn't deserialized yet, 
			// so we need to delay the checking for initializing the SqlDatabaseConfig
			// until a little later.
			Application.Idle += new EventHandler(CheckInitialize);
		}
	}
}