using Microsoft.Data.SqlClient;
using Eco.Handles.Design;

namespace Eco.Persistence.Design
{
	///<summary>
	///Validator to check that SqlConnection have relevant properties set.
	///</summary>
	public class PMapperSqlServerValidator: IFormValidator
	{
#region Implementation of IFormValidator
		///<summary>
		///Validates the component.
		///</summary>
		///<remarks>
		///Checks that a SqlConnection has the ConnectionString set. Yields a hint.
		///</remarks>
		public void ValidateComponent(FormValidatorArgs args)
		{
			SqlConnection connection = args.Component as SqlConnection;
			if (connection != null)
			{
				if (connection.ConnectionString.Length == 0)
					args.Report.AddHint(connection, PersistenceStringRes.ConnectionStringNotSet);
			}
		}
#endregion
	}
}