using System;
#if NETSTANDARD
#else
using System.EnterpriseServices;
#endif
using System.Data;
using System.Data.Common;
using Microsoft.Data.SqlClient;
using System.Collections;
using System.Collections.Specialized;
using System.Globalization;

using Eco.Persistence.Configuration;
using Eco.Persistence;
using System.Collections.Generic;

namespace Eco.Persistence.Connection
{
	public sealed class SqlIDatabaseImpl: Ado2IDatabaseImpl
	{
		public SqlIDatabaseImpl(DbConnection connection, SqlDatabaseConfig config):
			base(connection, config)
		{
		}

        public override IList<string> AllTableNames(string pattern)
		{
			EnsureConnected();
            IList<string> result = new List<string>();

			string[] restrictions = new string[4];
			restrictions[3] = "BASE TABLE"; // do not localize
			if (pattern.Length > 0)
				restrictions[2] = pattern;


          DataTable schema;
          if (Connection is System.Data.SqlServerCe.SqlCeConnection)
          {
            schema = Connection.GetSchema("TABLES"); // GetSchema with restrictions does not work on sqlCE  do not localize
            for (int i = schema.Rows.Count - 1; i >= 0; i--)
            {
              DataRow dr = schema.Rows[i];
              if ((!string.IsNullOrEmpty(pattern)) && ((dr["TABLE_NAME"] as string).ToLower() != pattern.ToLower()))
                schema.Rows.Remove(dr);
            }
          }
          else
            schema = Connection.GetSchema("TABLES", restrictions); // do not localize

			foreach (DataRow dr in schema.Rows)
			{
				result.Add((string)dr["TABLE_NAME"]); // do not localize
			}

			return result;
		}

		protected override string HandleCommandParameters(string commandText, IDataParameterCollection parameters)
		{
			return ConvertParametersToAtPrefix(commandText, parameters);
		}
#if NETSTANDARD
#else
    protected override void InternalEnlistInTransaction(object transaction)
		{
			if (transaction is ITransaction)
				(Connection as SqlConnection).EnlistDistributedTransaction((ITransaction)transaction);
			else
				base.InternalEnlistInTransaction(transaction);
		}
#endif
	}
}
